/*
 * ext.h
 *
 *  Created on: 25.06.2019
 *      Author: AndreR
 */

#pragma once

#include "util/uart_fifo.h"
#include "util/fifo_lin.h"
#include "util/cobs.h"
#include "commands.h"

#define EXT_TX_FIFO_SIZE 1024
#define EXT_MAX_PACKET_SIZE 128

typedef struct _EXTStats
{
	uint32_t rxWire;
	uint32_t rxPayload;
	uint32_t txWire;
	uint32_t txPayload;
	float rxUsage;
	float txUsage;
} EXTStats;

typedef struct _Ext
{
	uint8_t installed;

	uint32_t baudrate;

	binary_semaphore_t dataAvailable;

	UARTFifo uart;

	FifoLin txFifo;

	uint8_t txData[EXT_TX_FIFO_SIZE];

	uint8_t txProcessingBuf[COBSMaxStuffedSize(EXT_MAX_PACKET_SIZE)+1];
	uint8_t rxReceiveBuf[COBSMaxStuffedSize(EXT_MAX_PACKET_SIZE)+1];

	uint8_t rxProcessingBuf[COBSMaxStuffedSize(EXT_MAX_PACKET_SIZE)+1];
	uint16_t rxProcBufUsed;

	uint8_t rxDecodeBuf[EXT_MAX_PACKET_SIZE];

	EXTStats liveStats;
	EXTStats stats;
} Ext;

extern Ext ext;

void ExtInit(uint32_t baudrate);
void ExtTask(void* params);
int16_t ExtSendPacket(PacketHeader* pHeader, const void* _pData, uint16_t dataLength);
