/*
 * ir.h
 *
 *  Created on: 12.01.2019
 *      Author: AndreR
 */

#pragma once

#include "util/uart_fifo.h"
#include "util/st_bootloader.h"

typedef struct _IR
{
	UARTFifo uart;
	STBootloader bootloader;
	STBootloaderFlashResult flashResult;
	int16_t flashFuncResult;

	float vBarrier; // [V]
	float vLateral[6][6]; // [V]
	mutex_t mtxUart;
	float cpuLoad; // [%]
} IR;

extern IR ir;

void IrInit();
void IrFlashProgram(uint8_t force);
void IrTask(void* params);
