/*
 * hall.h
 *
 *  Created on: 22.01.2019
 *      Author: AndreR
 */

#pragma once

#include "stm32f031x6.h"

#define HALL_GET_POS() (GPIOA->IDR & 0x07)

typedef struct _HallData
{
	volatile uint8_t hallPos;
	volatile uint32_t encoderPos;
	uint8_t reverseHall;
	int32_t hallDeltaTime[3];
	uint32_t lastCCR[3];
} HallData;

extern HallData hall;

void		HallInit();
uint32_t	HallGetCommutationTime();
void		HallSetCommutationDelay(uint32_t ticks);
void		HallUpdate();
