/*
 * motor.h
 *
 *  Created on: 25.01.2019
 *      Author: AndreR
 */

#pragma once

#include <stdint.h>
#include "pi_ctrl_s12.h"

typedef struct _AngleLUTEntry
{
	int16_t VLow_S10_5; // -600 - 600
	int16_t VMid_S10_5;
	int16_t VHigh_S10_5;
	uint8_t lowIndex;
	uint8_t midIndex;
	uint8_t highIndex;
} AngleLUTEntry;

typedef struct _MotorData
{
	volatile uint16_t dmaData[12];
	volatile uint16_t encDmaData[2];

	// 0 - 4095, phase values without tCrit shifting (scaled)
	volatile int32_t VLowUsed_U12_0;
	volatile int32_t VMidUsed_U12_0;
	volatile int32_t VHighUsed_U12_0;

	volatile uint8_t phIndexLow;
	volatile uint8_t phIndexMid;
	volatile uint8_t phIndexHigh;

	uint8_t currentMode;
} MotorData;

extern MotorData motor;

void MotorInit();
void MotorUpdate();
void MotorSetAngle(uint16_t angle, int32_t voltage);
void MotorSetAlphaBeta(int32_t alpha_S12_15, int32_t beta_S12_15);
void MotorSetBlock(uint8_t phase, int32_t voltage);
