/*
 * intercom.c
 *
 *  Created on: 10.11.2012
 *      Author: AndreR
 */

#include "intercom.h"
#include "errors.h"
#include "log.h"
#include <string.h>

Intercom intercom;

int16_t IntercomSend(const IntercomHeader* pHeader, uint16_t dataLength, const void* _pData)
{
	for(uint8_t i = 0; i < intercom.numClientsUsed; i++)
	{
		if(intercom.clients[i].section == pHeader->section)
			(*intercom.clients[i].rxCallback)(pHeader, dataLength, _pData, intercom.clients[i].pUserData);
	}

	return 0;
}

int16_t IntercomAddClient(IntercomClient client)
{
	if(intercom.numClientsUsed == INTERCOM_MAX_CLIENTS)
	{
		LogError("Maximum number of intercom clients reached");
		return ERROR_INTERCOM_NO_FREE_SLOT;
	}

	intercom.clients[intercom.numClientsUsed] = client;
	intercom.numClientsUsed++;

	return 0;
}
