/*
 * intercom.h
 *
 *  Created on: 10.11.2012
 *      Author: AndreR
 */

#pragma once

#include <stdint.h>

#define INTERCOM_MAX_CLIENTS	32
#define INTERCOM_HEADER_SIZE	2

typedef union __attribute__ ((packed)) _IntercomHeader
{
	struct
	{
		uint8_t section;
		uint8_t command;
	};

	uint8_t _data[INTERCOM_HEADER_SIZE];
} IntercomHeader;

typedef void(*IntercomCallback)(const IntercomHeader*, uint16_t, const uint8_t*, void*);	//header, dataLength, data, userData

typedef struct _IntercomClient
{
	uint8_t section;
	IntercomCallback rxCallback;
	void* pUserData;
} IntercomClient;

typedef struct _Intercom
{
	IntercomClient clients[INTERCOM_MAX_CLIENTS];
	uint8_t numClientsUsed;
} Intercom;

extern Intercom intercom;

int16_t IntercomSend(const IntercomHeader* pHeader, uint16_t dataLength, const void* _pData);
int16_t IntercomAddClient(IntercomClient client);
